Quellcode durchsuchen

Merge branch 'master' of http://120.25.74.229:8003/ax-data-recieve/ax-beidou

minghao-chen vor 2 Jahren
Ursprung
Commit
ef742e9dd9
20 geänderte Dateien mit 835 neuen und 130 gelöschten Zeilen
  1. 33 0
      beidou-track-consumer/.gitignore
  2. 316 0
      beidou-track-consumer/mvnw
  3. 188 0
      beidou-track-consumer/mvnw.cmd
  4. 59 0
      beidou-track-consumer/pom.xml
  5. 13 0
      beidou-track-consumer/src/main/java/cn/com/taiji/beidou/track/BeidouTrackConsumerApplication.java
  6. 36 0
      beidou-track-consumer/src/main/resources/application-dev.yml
  7. 36 0
      beidou-track-consumer/src/main/resources/application-prod.yml
  8. 3 0
      beidou-track-consumer/src/main/resources/application.yml
  9. 15 0
      beidou-track-consumer/src/main/resources/log4j.properties
  10. 0 1
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/consumer/BeidouShipTrackConsumer.java
  11. 6 1
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/dto/BeidouShipLocationDTO.java
  12. 18 0
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/entity/ShipStatusEntity.java
  13. 6 2
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/mapper/BeidouLocationMapper.java
  14. 1 1
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/schedule/LocationSchedule.java
  15. 4 1
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/schedule/PersistenceSchedule.java
  16. 4 6
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/IShipStatusService.java
  17. 11 5
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/impl/BeidouLocationServiceImpl.java
  18. 78 106
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/impl/ShipStatusServiceImpl.java
  19. 6 5
      beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/impl/WarningRecordServiceImpl.java
  20. 2 2
      beidou-track-geomesa/src/main/resources/application-prod.yml

+ 33 - 0
beidou-track-consumer/.gitignore

@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/

+ 316 - 0
beidou-track-consumer/mvnw

@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#    https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+#   JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+#   M2_HOME - location of maven2's installed home dir
+#   MAVEN_OPTS - parameters passed to the Java VM when running Maven
+#     e.g. to debug Maven itself, use
+#       set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+#   MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+  if [ -f /usr/local/etc/mavenrc ] ; then
+    . /usr/local/etc/mavenrc
+  fi
+
+  if [ -f /etc/mavenrc ] ; then
+    . /etc/mavenrc
+  fi
+
+  if [ -f "$HOME/.mavenrc" ] ; then
+    . "$HOME/.mavenrc"
+  fi
+
+fi
+
+# OS specific support.  $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+  CYGWIN*) cygwin=true ;;
+  MINGW*) mingw=true;;
+  Darwin*) darwin=true
+    # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+    # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+    if [ -z "$JAVA_HOME" ]; then
+      if [ -x "/usr/libexec/java_home" ]; then
+        export JAVA_HOME="`/usr/libexec/java_home`"
+      else
+        export JAVA_HOME="/Library/Java/Home"
+      fi
+    fi
+    ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+  if [ -r /etc/gentoo-release ] ; then
+    JAVA_HOME=`java-config --jre-home`
+  fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+  ## resolve links - $0 may be a link to maven's home
+  PRG="$0"
+
+  # need this for relative symlinks
+  while [ -h "$PRG" ] ; do
+    ls=`ls -ld "$PRG"`
+    link=`expr "$ls" : '.*-> \(.*\)$'`
+    if expr "$link" : '/.*' > /dev/null; then
+      PRG="$link"
+    else
+      PRG="`dirname "$PRG"`/$link"
+    fi
+  done
+
+  saveddir=`pwd`
+
+  M2_HOME=`dirname "$PRG"`/..
+
+  # make it fully qualified
+  M2_HOME=`cd "$M2_HOME" && pwd`
+
+  cd "$saveddir"
+  # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+  [ -n "$M2_HOME" ] &&
+    M2_HOME=`cygpath --unix "$M2_HOME"`
+  [ -n "$JAVA_HOME" ] &&
+    JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+  [ -n "$CLASSPATH" ] &&
+    CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+  [ -n "$M2_HOME" ] &&
+    M2_HOME="`(cd "$M2_HOME"; pwd)`"
+  [ -n "$JAVA_HOME" ] &&
+    JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+  javaExecutable="`which javac`"
+  if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+    # readlink(1) is not available as standard on Solaris 10.
+    readLink=`which readlink`
+    if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+      if $darwin ; then
+        javaHome="`dirname \"$javaExecutable\"`"
+        javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+      else
+        javaExecutable="`readlink -f \"$javaExecutable\"`"
+      fi
+      javaHome="`dirname \"$javaExecutable\"`"
+      javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+      JAVA_HOME="$javaHome"
+      export JAVA_HOME
+    fi
+  fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+  if [ -n "$JAVA_HOME"  ] ; then
+    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+      # IBM's JDK on AIX uses strange locations for the executables
+      JAVACMD="$JAVA_HOME/jre/sh/java"
+    else
+      JAVACMD="$JAVA_HOME/bin/java"
+    fi
+  else
+    JAVACMD="`\\unset -f command; \\command -v java`"
+  fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+  echo "Error: JAVA_HOME is not defined correctly." >&2
+  echo "  We cannot execute $JAVACMD" >&2
+  exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+  echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+  if [ -z "$1" ]
+  then
+    echo "Path not specified to find_maven_basedir"
+    return 1
+  fi
+
+  basedir="$1"
+  wdir="$1"
+  while [ "$wdir" != '/' ] ; do
+    if [ -d "$wdir"/.mvn ] ; then
+      basedir=$wdir
+      break
+    fi
+    # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+    if [ -d "${wdir}" ]; then
+      wdir=`cd "$wdir/.."; pwd`
+    fi
+    # end of workaround
+  done
+  echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+  if [ -f "$1" ]; then
+    echo "$(tr -s '\n' ' ' < "$1")"
+  fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+  exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+    if [ "$MVNW_VERBOSE" = true ]; then
+      echo "Found .mvn/wrapper/maven-wrapper.jar"
+    fi
+else
+    if [ "$MVNW_VERBOSE" = true ]; then
+      echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+    fi
+    if [ -n "$MVNW_REPOURL" ]; then
+      jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+    else
+      jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+    fi
+    while IFS="=" read key value; do
+      case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+      esac
+    done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+    if [ "$MVNW_VERBOSE" = true ]; then
+      echo "Downloading from: $jarUrl"
+    fi
+    wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+    if $cygwin; then
+      wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+    fi
+
+    if command -v wget > /dev/null; then
+        if [ "$MVNW_VERBOSE" = true ]; then
+          echo "Found wget ... using wget"
+        fi
+        if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+            wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+        else
+            wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+        fi
+    elif command -v curl > /dev/null; then
+        if [ "$MVNW_VERBOSE" = true ]; then
+          echo "Found curl ... using curl"
+        fi
+        if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+            curl -o "$wrapperJarPath" "$jarUrl" -f
+        else
+            curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+        fi
+
+    else
+        if [ "$MVNW_VERBOSE" = true ]; then
+          echo "Falling back to using Java to download"
+        fi
+        javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+        # For Cygwin, switch paths to Windows format before running javac
+        if $cygwin; then
+          javaClass=`cygpath --path --windows "$javaClass"`
+        fi
+        if [ -e "$javaClass" ]; then
+            if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+                if [ "$MVNW_VERBOSE" = true ]; then
+                  echo " - Compiling MavenWrapperDownloader.java ..."
+                fi
+                # Compiling the Java class
+                ("$JAVA_HOME/bin/javac" "$javaClass")
+            fi
+            if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+                # Running the downloader
+                if [ "$MVNW_VERBOSE" = true ]; then
+                  echo " - Running MavenWrapperDownloader.java ..."
+                fi
+                ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+            fi
+        fi
+    fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+  echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+  [ -n "$M2_HOME" ] &&
+    M2_HOME=`cygpath --path --windows "$M2_HOME"`
+  [ -n "$JAVA_HOME" ] &&
+    JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+  [ -n "$CLASSPATH" ] &&
+    CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+  [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+    MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+  $MAVEN_OPTS \
+  $MAVEN_DEBUG_OPTS \
+  -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+  "-Dmaven.home=${M2_HOME}" \
+  "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+  ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"

+ 188 - 0
beidou-track-consumer/mvnw.cmd

@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements.  See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership.  The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License.  You may obtain a copy of the License at
+@REM
+@REM    https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied.  See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM     e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on"  echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+    IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+    if "%MVNW_VERBOSE%" == "true" (
+        echo Found %WRAPPER_JAR%
+    )
+) else (
+    if not "%MVNW_REPOURL%" == "" (
+        SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+    )
+    if "%MVNW_VERBOSE%" == "true" (
+        echo Couldn't find %WRAPPER_JAR%, downloading it ...
+        echo Downloading from: %DOWNLOAD_URL%
+    )
+
+    powershell -Command "&{"^
+		"$webclient = new-object System.Net.WebClient;"^
+		"if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+		"$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+		"}"^
+		"[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+		"}"
+    if "%MVNW_VERBOSE%" == "true" (
+        echo Finished downloading %WRAPPER_JAR%
+    )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+  %JVM_CONFIG_MAVEN_PROPS% ^
+  %MAVEN_OPTS% ^
+  %MAVEN_DEBUG_OPTS% ^
+  -classpath %WRAPPER_JAR% ^
+  "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+  %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%

+ 59 - 0
beidou-track-consumer/pom.xml

@@ -0,0 +1,59 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
+    <modelVersion>4.0.0</modelVersion>
+    <parent>
+        <artifactId>ax-beidou</artifactId>
+        <groupId>cn.com.taiji</groupId>
+        <version>1.0.0</version>
+    </parent>
+    <groupId>cn.com.taiji</groupId>
+    <artifactId>beidou-track-consumer</artifactId>
+    <version>0.0.1-SNAPSHOT</version>
+    <name>beidou-track-consumer</name>
+    <description>beidou-track-consumer</description>
+    <properties>
+        <fastjson.version>1.2.60</fastjson.version>
+    </properties>
+    <dependencies>
+        <dependency>
+            <groupId>org.springframework.boot</groupId>
+            <artifactId>spring-boot-starter</artifactId>
+        </dependency>
+        <dependency>
+            <groupId>org.projectlombok</groupId>
+            <artifactId>lombok</artifactId>
+            <optional>true</optional>
+        </dependency>
+        <dependency>
+            <groupId>org.springframework.kafka</groupId>
+            <artifactId>spring-kafka</artifactId>
+        </dependency>
+        <dependency>
+            <groupId>com.alibaba</groupId>
+            <artifactId>fastjson</artifactId>
+            <version>${fastjson.version}</version>
+        </dependency>
+    </dependencies>
+
+    <build>
+        <plugins>
+            <plugin>
+                <groupId>org.springframework.boot</groupId>
+                <artifactId>spring-boot-maven-plugin</artifactId>
+                <version>2.2.6.RELEASE</version>
+                <configuration>
+                    <classifier>exec</classifier>
+                </configuration>
+                <executions>
+                    <execution>
+                        <goals>
+                            <goal>repackage</goal>
+                        </goals>
+                    </execution>
+                </executions>
+            </plugin>
+        </plugins>
+    </build>
+
+</project>

+ 13 - 0
beidou-track-consumer/src/main/java/cn/com/taiji/beidou/track/BeidouTrackConsumerApplication.java

@@ -0,0 +1,13 @@
+package cn.com.taiji.beidou.track;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class BeidouTrackConsumerApplication {
+
+    public static void main(String[] args) {
+        SpringApplication.run(BeidouTrackConsumerApplication.class, args);
+    }
+
+}

+ 36 - 0
beidou-track-consumer/src/main/resources/application-dev.yml

@@ -0,0 +1,36 @@
+spring:
+  kafka:
+    bootstrap-servers: 172.28.19.20:29092
+    producer:
+      # 发生错误后,消息重发的次数。
+      retries: 0
+      #当有多个消息需要被发送到同一个分区时,生产者会把它们放在同一个批次里。该参数指定了一个批次可以使用的内存大小,按照字节数计算。
+      batch-size: 16384
+      # 设置生产者内存缓冲区的大小。
+      buffer-memory: 33554432
+      # 键的序列化方式
+      key-serializer: org.apache.kafka.common.serialization.StringSerializer
+      # 值的序列化方式
+      value-serializer: org.apache.kafka.common.serialization.StringSerializer
+      # acks=0 : 生产者在成功写入消息之前不会等待任何来自服务器的响应。
+      # acks=1 : 只要集群的首领节点收到消息,生产者就会收到一个来自服务器成功响应。
+      # acks=all :只有当所有参与复制的节点全部收到消息时,生产者才会收到一个来自服务器的成功响应。
+      acks: 1
+    consumer:
+      # 自动提交的时间间隔 在spring boot 2.X 版本中这里采用的是值的类型为Duration 需要符合特定的格式,如1S,1M,2H,5D
+      auto-commit-interval: 1S
+      # 该属性指定了消费者在读取一个没有偏移量的分区或者偏移量无效的情况下该作何处理:
+      # latest(默认值)在偏移量无效的情况下,消费者将从最新的记录开始读取数据(在消费者启动之后生成的记录)
+      # earliest :在偏移量无效的情况下,消费者将从起始位置读取分区的记录
+      auto-offset-reset: latest
+      # 是否自动提交偏移量,默认值是true,为了避免出现重复数据和数据丢失,可以把它设置为false,然后手动提交偏移量
+      enable-auto-commit: false
+      key-deserializer: org.apache.kafka.common.serialization.StringDeserializer
+      value-deserializer: org.apache.kafka.common.serialization.StringDeserializer
+    listener:
+      # 在侦听器容器中运行的线程数。
+      concurrency: 5
+      #listner负责ack,每调用一次,就立即commit
+      ack-mode: manual_immediate
+      missing-topics-fatal: false
+      type: batch

+ 36 - 0
beidou-track-consumer/src/main/resources/application-prod.yml

@@ -0,0 +1,36 @@
+spring:
+  kafka:
+    bootstrap-servers: 172.28.19.20:29092
+    producer:
+      # 发生错误后,消息重发的次数。
+      retries: 0
+      #当有多个消息需要被发送到同一个分区时,生产者会把它们放在同一个批次里。该参数指定了一个批次可以使用的内存大小,按照字节数计算。
+      batch-size: 16384
+      # 设置生产者内存缓冲区的大小。
+      buffer-memory: 33554432
+      # 键的序列化方式
+      key-serializer: org.apache.kafka.common.serialization.StringSerializer
+      # 值的序列化方式
+      value-serializer: org.apache.kafka.common.serialization.StringSerializer
+      # acks=0 : 生产者在成功写入消息之前不会等待任何来自服务器的响应。
+      # acks=1 : 只要集群的首领节点收到消息,生产者就会收到一个来自服务器成功响应。
+      # acks=all :只有当所有参与复制的节点全部收到消息时,生产者才会收到一个来自服务器的成功响应。
+      acks: 1
+    consumer:
+      # 自动提交的时间间隔 在spring boot 2.X 版本中这里采用的是值的类型为Duration 需要符合特定的格式,如1S,1M,2H,5D
+      auto-commit-interval: 1S
+      # 该属性指定了消费者在读取一个没有偏移量的分区或者偏移量无效的情况下该作何处理:
+      # latest(默认值)在偏移量无效的情况下,消费者将从最新的记录开始读取数据(在消费者启动之后生成的记录)
+      # earliest :在偏移量无效的情况下,消费者将从起始位置读取分区的记录
+      auto-offset-reset: latest
+      # 是否自动提交偏移量,默认值是true,为了避免出现重复数据和数据丢失,可以把它设置为false,然后手动提交偏移量
+      enable-auto-commit: false
+      key-deserializer: org.apache.kafka.common.serialization.StringDeserializer
+      value-deserializer: org.apache.kafka.common.serialization.StringDeserializer
+    listener:
+      # 在侦听器容器中运行的线程数。
+      concurrency: 5
+      #listner负责ack,每调用一次,就立即commit
+      ack-mode: manual_immediate
+      missing-topics-fatal: false
+      type: batch

+ 3 - 0
beidou-track-consumer/src/main/resources/application.yml

@@ -0,0 +1,3 @@
+spring:
+  profiles:
+    active: prod

+ 15 - 0
beidou-track-consumer/src/main/resources/log4j.properties

@@ -0,0 +1,15 @@
+# log to stdout by default
+log4j.rootLogger=info, stdout
+
+# set logging levels to appropriate values
+log4j.logger.org.locationtech.geomesa=info
+log4j.logger.org.apache.zookeeper=warn
+log4j.logger.org.apache.curator=warn
+log4j.logger.org.apache.hadoop=warn
+log4j.logger.org.apache.redis=warn
+log4j.logger.hsqldb.db=warn
+
+# log to stderr by default instead of std out
+log4j.appender.stdout=org.apache.log4j.ConsoleAppender
+log4j.appender.stdout.layout=org.apache.log4j.PatternLayout
+log4j.appender.stdout.Target=System.out

+ 0 - 1
beidou-track-geomesa/src/main/java/cn/com/taiji/track/consumer/BeidouShipTrackConsumer.java

@@ -32,7 +32,6 @@ public class BeidouShipTrackConsumer {
             topics = {"${taiji.kafka.consumer.beidou.topic}"}
     )
     public void dynamicTrack(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) {
-//        beidouTrackService.beidouDynamicShipToRedis(records);
         beidouTrackService.beidouDynamicShipToCache(records);
         beidouTrackService.beidouDynamicShipToKafka(records);
         beidouLocationService.beidouDynamicShipToCache(records);

+ 6 - 1
beidou-track-geomesa/src/main/java/cn/com/taiji/track/dto/BeidouShipLocationDTO.java

@@ -45,6 +45,7 @@ public class BeidouShipLocationDTO extends IGeomesaTrackDTO implements Serializa
     private String isInport;
     private String isAnchor;
     private String deviceStatus;
+    private String xwDeptId;
 
     @Override
     public boolean checkPoint() {
@@ -98,6 +99,7 @@ public class BeidouShipLocationDTO extends IGeomesaTrackDTO implements Serializa
             attributes.append("isInport:String,");
             attributes.append("isAnchor:String,");
             attributes.append("deviceStatus:String,");
+            attributes.append("xwDeptId:String,");
 
             attributes.append("layerType:String,");
             attributes.append("syncTime:Date");
@@ -131,6 +133,7 @@ public class BeidouShipLocationDTO extends IGeomesaTrackDTO implements Serializa
         }else{
             builder.set("deviceStatus", 0);
         }
+        builder.set("xwDeptId", xwDeptId);
 
         builder.set("layerType", getLayerType());
         builder.set("syncTime", new Date());
@@ -141,7 +144,7 @@ public class BeidouShipLocationDTO extends IGeomesaTrackDTO implements Serializa
     @Override
     public String[] getPropList(){
         return new String[] {
-//                "deviceId",
+                "deviceId",
                 "location",
                 "shipType",
                 "workType",
@@ -162,6 +165,7 @@ public class BeidouShipLocationDTO extends IGeomesaTrackDTO implements Serializa
                 "isInport",
                 "isAnchor",
                 "deviceStatus",
+                "xwDeptId",
                 "layerType",
                 "syncTime"
         };
@@ -191,6 +195,7 @@ public class BeidouShipLocationDTO extends IGeomesaTrackDTO implements Serializa
                 isInport,
                 isAnchor,
                 deviceStatus,
+                xwDeptId,
                 getLayerType(),
                 new Date()
         };

+ 18 - 0
beidou-track-geomesa/src/main/java/cn/com/taiji/track/entity/ShipStatusEntity.java

@@ -1,5 +1,6 @@
 package cn.com.taiji.track.entity;
 
+import cn.com.taiji.track.constants.WarningCodeConstants;
 import com.baomidou.mybatisplus.annotation.EnumValue;
 import com.baomidou.mybatisplus.annotation.TableId;
 import com.baomidou.mybatisplus.annotation.TableName;
@@ -54,6 +55,14 @@ public class ShipStatusEntity{
         @JsonValue    //需要在前端展示哪个值就在哪个属性上加上该注解
         private String text;
 
+        public static OnlineStatus getStatus(String start) {
+            if("true".equals(start)){
+                return ONLINE;
+            }else{
+                return OFFLINE;
+            }
+        }
+
         public String getValue() {
             return value;
         }
@@ -71,6 +80,15 @@ public class ShipStatusEntity{
         @JsonValue    //需要在前端展示哪个值就在哪个属性上加上该注解
         private String text;
 
+        public static InportStatus getStatus(String inportCode) {
+            switch (inportCode) {
+                case WarningCodeConstants.INPORT_WARNING:
+                    return TRUE;
+                default:
+                    return FALSE;
+            }
+        }
+
         public String getValue() {
             return value;
         }

+ 6 - 2
beidou-track-geomesa/src/main/java/cn/com/taiji/track/mapper/BeidouLocationMapper.java

@@ -17,10 +17,14 @@ import java.util.List;
  */
 @Mapper
 public interface BeidouLocationMapper extends BaseMapper<BeidouLocationEntity> {
-    @Select("SELECT l.*,s.is_online,s.is_inport,s.is_anchor,d.dispose_type " +
+    @Select("SELECT l.*,s.is_online,s.is_inport,s.is_anchor,d.dispose_type,dept.xw_dept_id,\n" +
+            "IFNULL(l.ship_name,ship_id) AS ship_name\n" +
             "FROM ax_beidou_ship_location l\n" +
             "LEFT JOIN ax_beidou_ship_status s on s.device_id = l.device_id\n" +
-            "LEFT JOIN ax_beidou_ship_dispose d on d.devide_no = l.device_id")
+            "LEFT JOIN ax_beidou_ship_dispose d on d.devide_no = l.device_id\n" +
+            "LEFT JOIN ax_beidou_ship_archives a on a.devide_no = l.device_id\n" +
+            "LEFT JOIN ax_beidou_dept dept on dept.pscbh = a.police_station_id\n" +
+            "ORDER BY device_id,location_time")
     List<BeidouShipLocationDTO> listLocation();
 }
 

+ 1 - 1
beidou-track-geomesa/src/main/java/cn/com/taiji/track/schedule/LocationSchedule.java

@@ -17,7 +17,7 @@ public class LocationSchedule {
     @Autowired
     private IBeidouLocationService beidouLocationService;
 
-    @Scheduled(cron = "*/3 * * * * ?")
+    @Scheduled(cron = "*/30 * * * * ?")
     private void listLocationToCache() {
         beidouLocationService.listLocationToCache();
     }

+ 4 - 1
beidou-track-geomesa/src/main/java/cn/com/taiji/track/schedule/PersistenceSchedule.java

@@ -36,7 +36,10 @@ public class PersistenceSchedule {
         beidouLocationService.cacheBeidouToMySql();
     }
     @Scheduled(cron = "*/10 * * * * ?")
-    private void cacheStatusToMySql() { shipStatusService.cacheToMySql();}
+    private void cacheStatusToMySql() {
+//        shipStatusService.cacheToMySql();
+        shipStatusService.onlineCacheToMySql();
+    }
     @Scheduled(cron = "*/10 * * * * ?")
     private void anchorCacheToMySql() { shipStatusService.anchorCacheToMySql();}
     @Scheduled(cron = "*/10 * * * * ?")

+ 4 - 6
beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/IShipStatusService.java

@@ -10,12 +10,6 @@ import java.util.Map;
  */
 public interface IShipStatusService extends IService<ShipStatusEntity> {
 
-    void pushOffLineDeviceId(String deviceId);
-
-    void cacheToMySql();
-
-    void pushOnLineDeviceId(String deviceId);
-
     void anchorCacheToMySql();
 
     void pushAnchorDeviceId(String deviceId, String start);
@@ -23,4 +17,8 @@ public interface IShipStatusService extends IService<ShipStatusEntity> {
     void pushinportDeviceId(String deviceId, String inportWarning);
 
     void InportCacheToMySql();
+
+    void pushOnLineDeviceId(String deviceId, String start);
+
+    void onlineCacheToMySql();
 }

+ 11 - 5
beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/impl/BeidouLocationServiceImpl.java

@@ -66,7 +66,7 @@ public class BeidouLocationServiceImpl extends ServiceImpl<BeidouLocationMapper,
                     BigDecimal latitudeDecimal = new BigDecimal(locationEntity.getLatitude());
                     locationEntity.setLatitude(LatLngUtil.latLng2Dfm(latitudeDecimal.doubleValue()));
                     locationEntities.add(locationEntity);
-                    shipStatusService.pushOnLineDeviceId(locationEntity.getDeviceId());
+                    shipStatusService.pushOnLineDeviceId(locationEntity.getDeviceId(),"true");
                 }
             }
         } catch (Exception e) {
@@ -81,12 +81,13 @@ public class BeidouLocationServiceImpl extends ServiceImpl<BeidouLocationMapper,
             List<BeidouLocationEntity> saveList = new ArrayList<>(locationEntities);
             locationEntities.clear();
             saveBatch(saveList);
-//            log.info("位置数据写入数据库完成!耗时 {} 毫秒, 合计保存 {} 条记录", (new Date()).getTime() - begin.getTime(), saveList.size());
+            log.info("位置数据写入数据库完成!耗时 {} 毫秒, 合计保存 {} 条记录", (new Date()).getTime() - begin.getTime(), saveList.size());
         }
     }
 
     @Override
     public void listLocationToCache() {
+        Date begin = new Date();
         List<BeidouShipLocationDTO> results = baseMapper.listLocation();
         if (results.size() > 0) {
             FeatureReader<SimpleFeatureType, SimpleFeature> reader = null;
@@ -114,9 +115,13 @@ public class BeidouLocationServiceImpl extends ServiceImpl<BeidouLocationMapper,
                     reader = redisDataStore.getFeatureReader(query, Transaction.AUTO_COMMIT);
                     if (reader.hasNext()) {
                         append = false;
-                        String[] propList = dto.getPropList();
-                        Object[] valueList = dto.getValueList();
-                        redisDataStore.getFeatureSource(dto.getTypeName()).modifyFeatures(propList, valueList, filter);
+                        SimpleFeature feature=reader.next();
+                        String locationTime = feature.getAttribute("locationTime").toString();
+                        if(!locationTime.equals(String.valueOf(dto.getValueList()[6]))){
+                            String[] propList = dto.getPropList();
+                            Object[] valueList = dto.getValueList();
+                            redisDataStore.getFeatureSource(dto.getTypeName()).modifyFeatures(propList, valueList, filter);
+                        }
                     }
                     reader.close();
                     reader = null;
@@ -147,6 +152,7 @@ public class BeidouLocationServiceImpl extends ServiceImpl<BeidouLocationMapper,
                     e.printStackTrace();
                 }
             }
+//            log.info("位置数据插入geomesa完成!耗时 {} 毫秒, 合计保存 {} 条记录", (new Date()).getTime() - begin.getTime(), results.size());
         }
     }
 }

+ 78 - 106
beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/impl/ShipStatusServiceImpl.java

@@ -4,7 +4,6 @@ import cn.com.taiji.track.constants.WarningCodeConstants;
 import cn.com.taiji.track.entity.ShipStatusEntity;
 import cn.com.taiji.track.mapper.ShipStatusMapper;
 import cn.com.taiji.track.service.IShipStatusService;
-import com.alibaba.druid.util.StringUtils;
 import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
 import lombok.extern.slf4j.Slf4j;
 import org.springframework.stereotype.Service;
@@ -19,19 +18,13 @@ import java.util.concurrent.ConcurrentHashMap;
 @Slf4j
 public class ShipStatusServiceImpl extends ServiceImpl<ShipStatusMapper, ShipStatusEntity> implements IShipStatusService {
 
-    private Vector<String> offLineDeviceIds= new Vector<>();
-    private Vector<String> onLineDeviceIds= new Vector<>();
+    private Map<String, String> onlineMap= new ConcurrentHashMap<>();
     private Map<String, String> anchorMap= new ConcurrentHashMap<>();
     private Map<String, String> inportMap= new ConcurrentHashMap<>();
 
     @Override
-    public void pushOffLineDeviceId(String deviceId){
-        offLineDeviceIds.add(deviceId);
-    }
-
-    @Override
-    public void pushOnLineDeviceId(String deviceId) {
-        onLineDeviceIds.add(deviceId);
+    public void pushOnLineDeviceId(String deviceId, String start) {
+        onlineMap.put(deviceId, start);
     }
 
     @Override
@@ -45,75 +38,34 @@ public class ShipStatusServiceImpl extends ServiceImpl<ShipStatusMapper, ShipSta
     }
 
     @Override
-    public void cacheToMySql() {
-        Date begin = new Date();
-        List<ShipStatusEntity> saveList = new ArrayList<>();
-        if(offLineDeviceIds.size() > 0){
-            List<String> idList = new ArrayList<>(offLineDeviceIds);
-            offLineDeviceIds.clear();
-            for (String id : idList) {
-                ShipStatusEntity entity = baseMapper.selectById(id);
-                if (entity == null) {
-                    entity = new ShipStatusEntity();
-                    entity.setDeviceId(id);
-                    entity.setIsOnline(ShipStatusEntity.OnlineStatus.OFFLINE);
-                    entity.setOnlineChangeTime(new Date());
-                    saveList.add(entity);
-                }else if (ShipStatusEntity.OnlineStatus.ONLINE.equals(entity.getIsOnline())) {
-                    entity.setIsOnline(ShipStatusEntity.OnlineStatus.OFFLINE);
-                    entity.setOnlineChangeTime(new Date());
-                    saveList.add(entity);
-                }
-            }
-        }
-        if(onLineDeviceIds.size() > 0){
-            List<String> idList = new ArrayList<>(onLineDeviceIds);
-            onLineDeviceIds.clear();
-            for (String id : idList) {
-                ShipStatusEntity entity = baseMapper.selectById(id);
-                if (entity == null) {
-                    entity = new ShipStatusEntity();
-                    entity.setDeviceId(id);
-                    entity.setIsOnline(ShipStatusEntity.OnlineStatus.ONLINE);
-                    entity.setOnlineChangeTime(new Date());
-                    saveList.add(entity);
-                }else if (ShipStatusEntity.OnlineStatus.OFFLINE.equals(entity.getIsOnline())) {
-                    entity.setIsOnline(ShipStatusEntity.OnlineStatus.ONLINE);
-                    entity.setOnlineChangeTime(new Date());
-                    saveList.add(entity);
-                }
-            }
-        }
-        if(!saveList.isEmpty()){
-            saveBatch(saveList);
-            log.info("船舶状态写入数据库完成!耗时 {} 毫秒, 合计保存 {} 条记录", (new Date()).getTime() - begin.getTime(), saveList.size());
-        }
-    }
-
-    @Override
     public void anchorCacheToMySql() {
         Date begin = new Date();
         List<ShipStatusEntity> saveList = new ArrayList<>();
         if(anchorMap.size() > 0){
             Map<String,String> map = new HashMap<>(anchorMap);
             anchorMap.clear();
+            List<ShipStatusEntity> statusEntityList = baseMapper.selectBatchIds(map.keySet());
+            if(statusEntityList.size() > 0) {
+                for(ShipStatusEntity statusEntity : statusEntityList){
+                    String start = map.get(statusEntity.getDeviceId());
+                    ShipStatusEntity.AnchorStatus status = ShipStatusEntity.AnchorStatus.getStatus(start);
+                    if(!status.equals(statusEntity.getIsAnchor())){
+                        statusEntity.setIsAnchor(status);
+                        saveList.add(statusEntity);
+                    }
+                    map.remove(statusEntity.getDeviceId());
+                }
+            }
             for (String id : map.keySet()) {
                 String start = map.get(id);
-                ShipStatusEntity entity = baseMapper.selectById(id);
                 ShipStatusEntity.AnchorStatus status = ShipStatusEntity.AnchorStatus.getStatus(start);
-                if (entity == null) {
-                    entity = new ShipStatusEntity();
-                    entity.setDeviceId(id);
-                    entity.setIsOnline(ShipStatusEntity.OnlineStatus.ONLINE);
-                    entity.setOnlineChangeTime(new Date());
-                    entity.setIsAnchor(status);
-                    entity.setAnchorChangeTime(new Date());
-                    saveList.add(entity);
-                }else if (!status.equals(entity.getIsAnchor())) {
-                    entity.setIsAnchor(status);
-                    entity.setAnchorChangeTime(new Date());
-                    saveList.add(entity);
-                }
+                ShipStatusEntity entity = new ShipStatusEntity();
+                entity.setDeviceId(id);
+                entity.setIsOnline(ShipStatusEntity.OnlineStatus.ONLINE);
+                entity.setOnlineChangeTime(new Date());
+                entity.setIsAnchor(status);
+                entity.setAnchorChangeTime(new Date());
+                saveList.add(entity);
             }
         }
         if(!saveList.isEmpty()){
@@ -128,48 +80,68 @@ public class ShipStatusServiceImpl extends ServiceImpl<ShipStatusMapper, ShipSta
         if (inportMap.size() > 0) {
             Map<String, String> map = new HashMap<>(inportMap);
             inportMap.clear();
-            for (String deviceId : map.keySet()) {
-                String inportCode = map.get(deviceId);
-                ShipStatusEntity entity = baseMapper.selectById(deviceId);
-                switch (inportCode) {
-                    case WarningCodeConstants.INPORT_WARNING:
-                        if (entity == null) {
-                            entity = new ShipStatusEntity();
-                            entity.setDeviceId(deviceId);
-                            entity.setIsOnline(ShipStatusEntity.OnlineStatus.ONLINE);
-                            entity.setOnlineChangeTime(new Date());
-                            entity.setIsInport(ShipStatusEntity.InportStatus.TRUE);
-                            entity.setInportChangeTime(new Date());
-                            saveList.add(entity);
-                        } else {
-                            entity.setIsInport(ShipStatusEntity.InportStatus.TRUE);
-                            entity.setInportChangeTime(new Date());
-                            saveList.add(entity);
-                        }
-                        break;
-                    case WarningCodeConstants.OUTPROT_WARNING:
-                        if (entity == null) {
-                            entity = new ShipStatusEntity();
-                            entity.setDeviceId(deviceId);
-                            entity.setIsOnline(ShipStatusEntity.OnlineStatus.ONLINE);
-                            entity.setOnlineChangeTime(new Date());
-                            entity.setIsInport(ShipStatusEntity.InportStatus.FALSE);
-                            entity.setInportChangeTime(new Date());
-                            saveList.add(entity);
-                        } else {
-                            entity.setIsInport(ShipStatusEntity.InportStatus.FALSE);
-                            entity.setInportChangeTime(new Date());
-                            saveList.add(entity);
-                        }
-                        break;
-                    default:
-                        break;
+            List<ShipStatusEntity> statusEntityList = baseMapper.selectBatchIds(map.keySet());
+            if(statusEntityList.size() > 0) {
+                for(ShipStatusEntity statusEntity : statusEntityList){
+                    String inportCode = map.get(statusEntity.getDeviceId());
+                    ShipStatusEntity.InportStatus status = ShipStatusEntity.InportStatus.getStatus(inportCode);
+                    if(!status.equals(statusEntity.getIsAnchor())){
+                        statusEntity.setIsInport(status);
+                        saveList.add(statusEntity);
+                    }
+                    map.remove(statusEntity.getDeviceId());
                 }
             }
+            for (String id : map.keySet()) {
+                String inportCode = map.get(id);
+                ShipStatusEntity.InportStatus status = ShipStatusEntity.InportStatus.getStatus(inportCode);
+                ShipStatusEntity entity = new ShipStatusEntity();
+                entity.setDeviceId(id);
+                entity.setIsOnline(ShipStatusEntity.OnlineStatus.ONLINE);
+                entity.setOnlineChangeTime(new Date());
+                entity.setIsInport(status);
+                entity.setInportChangeTime(new Date());
+                saveList.add(entity);
+            }
             if (!saveList.isEmpty()) {
                 saveBatch(saveList);
                 log.info("进出港状态写入数据库完成!耗时 {} 毫秒, 合计保存 {} 条记录", (new Date()).getTime() - begin.getTime(), saveList.size());
             }
         }
     }
+
+    @Override
+    public void onlineCacheToMySql() {
+        Date begin = new Date();
+        List<ShipStatusEntity> saveList = new ArrayList<>();
+        if(onlineMap.size() > 0) {
+            Map<String, String> map = new HashMap<>(onlineMap);
+            onlineMap.clear();
+            List<ShipStatusEntity> statusEntityList = baseMapper.selectBatchIds(map.keySet());
+            if(statusEntityList.size() > 0){
+                for(ShipStatusEntity statusEntity : statusEntityList){
+                    String start = map.get(statusEntity.getDeviceId());
+                    ShipStatusEntity.OnlineStatus status = ShipStatusEntity.OnlineStatus.getStatus(start);
+                    if(!status.equals(statusEntity.getIsOnline())){
+                        statusEntity.setIsOnline(status);
+                        saveList.add(statusEntity);
+                    }
+                    map.remove(statusEntity.getDeviceId());
+                }
+            }
+            for (String id : map.keySet()) {
+                String start = map.get(id);
+                ShipStatusEntity.OnlineStatus status = ShipStatusEntity.OnlineStatus.getStatus(start);
+                ShipStatusEntity entity = new ShipStatusEntity();
+                entity.setDeviceId(id);
+                entity.setIsOnline(status);
+                entity.setOnlineChangeTime(new Date());
+                saveList.add(entity);
+            }
+        }
+        if(!saveList.isEmpty()){
+            saveBatch(saveList);
+            log.info("船舶状态写入数据库完成!耗时 {} 毫秒, 合计保存 {} 条记录", (new Date()).getTime() - begin.getTime(), saveList.size());
+        }
+    }
 }

+ 6 - 5
beidou-track-geomesa/src/main/java/cn/com/taiji/track/service/impl/WarningRecordServiceImpl.java

@@ -42,11 +42,12 @@ public class WarningRecordServiceImpl extends ServiceImpl<WarningRecordMapper, W
                     entity.setUpdateTime(new Date());
                     entities.add(entity);
                     if (WarningCodeConstants.OFFLINE_WARNING.equals(entity.getModelCode())) {
-                        if("true".equals(entity.getStart())){
-                            shipStatusService.pushOffLineDeviceId(entity.getDeviceId());
-                        }else{
-                            shipStatusService.pushOnLineDeviceId(entity.getDeviceId());
-                        }
+                        shipStatusService.pushOnLineDeviceId(entity.getDeviceId(),entity.getStart());
+//                        if("true".equals(entity.getStart())){
+//                            shipStatusService.pushOffLineDeviceId(entity.getDeviceId());
+//                        }else{
+//                            shipStatusService.pushOnLineDeviceId(entity.getDeviceId());
+//                        }
                     }
                     if (WarningCodeConstants.ANCHOR_WARNING.equals(entity.getModelCode())) {
                         shipStatusService.pushAnchorDeviceId(entity.getDeviceId(),entity.getStart());

+ 2 - 2
beidou-track-geomesa/src/main/resources/application-prod.yml

@@ -106,10 +106,10 @@ taiji:
       beidou:
         topic: taiji_ax_beidou_dynamic_ship
     consumer:
-      bootstrap-servers: 10.112.89.239:9092
+      bootstrap-servers: 172.28.19.20:29092
       beidou:
         enable: true
-        expiry: 70
+        expiry: 3600
         topic: sgAxBeidouTrack
         group: sgAxBeidouTrack—${random.uuid}
       warning: